// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_CONTAINERS_SET_H
#define FENNEC_TEST_CONTAINERS_SET_H

#include "../../test.h"

#include <cstdlib>
#include <unordered_set>
#include <fennec/containers/set.h>

namespace fennec::test
{

	inline void fennec_test_containers_set() {

		using type_t = decltype(rand());
		list<type_t> ref;
		set<type_t> test;

		int n = 50;
		for (int i = 0; i < n; ++i) {
			type_t v = rand();
			test.insert(v);
			ref.push_back(v);
		}

		for (int i = 0; i < n; ++i) {
			type_t v = ref[i];
			assertf(test.contains(v), "set test failed");
		}

		std::cout << "passed" << std::endl;
	}

}

#endif // FENNEC_TEST_CONTAINERS_SET_H
